

{- |
Copyright  : Will Thompson, Iñaki García Etxebarria and Jonas Platte
License    : LGPL-2.1
Maintainer : Iñaki García Etxebarria (garetxe@gmail.com)

Information about an annotation.
-}

module GI.Gio.Structs.DBusAnnotationInfo
    ( 

-- * Exported types
    DBusAnnotationInfo(..)                  ,
    newZeroDBusAnnotationInfo               ,
    noDBusAnnotationInfo                    ,


 -- * Methods
-- ** dBusAnnotationInfoLookup
    dBusAnnotationInfoLookup                ,


-- ** dBusAnnotationInfoRef
    DBusAnnotationInfoRefMethodInfo         ,
    dBusAnnotationInfoRef                   ,


-- ** dBusAnnotationInfoUnref
    DBusAnnotationInfoUnrefMethodInfo       ,
    dBusAnnotationInfoUnref                 ,




 -- * Properties
-- ** Annotations
    dBusAnnotationInfoReadAnnotations       ,


-- ** Key
    dBusAnnotationInfoReadKey               ,


-- ** RefCount
    dBusAnnotationInfoReadRefCount          ,


-- ** Value
    dBusAnnotationInfoReadValue             ,




    ) where

import Prelude ()
import Data.GI.Base.ShortPrelude

import qualified Data.Text as T
import qualified Data.ByteString.Char8 as B
import qualified Data.Map as Map

import GI.Gio.Types
import GI.Gio.Callbacks

newtype DBusAnnotationInfo = DBusAnnotationInfo (ForeignPtr DBusAnnotationInfo)
foreign import ccall "g_dbus_annotation_info_get_type" c_g_dbus_annotation_info_get_type :: 
    IO GType

instance BoxedObject DBusAnnotationInfo where
    boxedType _ = c_g_dbus_annotation_info_get_type

-- | Construct a `DBusAnnotationInfo` struct initialized to zero.
newZeroDBusAnnotationInfo :: MonadIO m => m DBusAnnotationInfo
newZeroDBusAnnotationInfo = liftIO $ callocBoxedBytes 32 >>= wrapBoxed DBusAnnotationInfo

noDBusAnnotationInfo :: Maybe DBusAnnotationInfo
noDBusAnnotationInfo = Nothing

dBusAnnotationInfoReadRefCount :: DBusAnnotationInfo -> IO Int32
dBusAnnotationInfoReadRefCount s = withManagedPtr s $ \ptr -> do
    val <- peek (ptr `plusPtr` 0) :: IO Int32
    return val

dBusAnnotationInfoReadKey :: DBusAnnotationInfo -> IO T.Text
dBusAnnotationInfoReadKey s = withManagedPtr s $ \ptr -> do
    val <- peek (ptr `plusPtr` 8) :: IO CString
    val' <- cstringToText val
    return val'

dBusAnnotationInfoReadValue :: DBusAnnotationInfo -> IO T.Text
dBusAnnotationInfoReadValue s = withManagedPtr s $ \ptr -> do
    val <- peek (ptr `plusPtr` 16) :: IO CString
    val' <- cstringToText val
    return val'

dBusAnnotationInfoReadAnnotations :: DBusAnnotationInfo -> IO [DBusAnnotationInfo]
dBusAnnotationInfoReadAnnotations s = withManagedPtr s $ \ptr -> do
    val <- peek (ptr `plusPtr` 24) :: IO (Ptr (Ptr DBusAnnotationInfo))
    val' <- unpackZeroTerminatedPtrArray val
    val'' <- mapM (newBoxed DBusAnnotationInfo) val'
    return val''

-- method DBusAnnotationInfo::ref
-- method type : OrdinaryMethod
-- Args : [Arg {argCName = "_obj", argType = TInterface "Gio" "DBusAnnotationInfo", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, argCallerAllocates = False, transfer = TransferNothing}]
-- Lengths : []
-- returnType : TInterface "Gio" "DBusAnnotationInfo"
-- throws : False
-- Skip return : False

foreign import ccall "g_dbus_annotation_info_ref" g_dbus_annotation_info_ref :: 
    Ptr DBusAnnotationInfo ->               -- _obj : TInterface "Gio" "DBusAnnotationInfo"
    IO (Ptr DBusAnnotationInfo)


dBusAnnotationInfoRef ::
    (MonadIO m) =>
    DBusAnnotationInfo                      -- _obj
    -> m DBusAnnotationInfo                 -- result
dBusAnnotationInfoRef _obj = liftIO $ do
    let _obj' = unsafeManagedPtrGetPtr _obj
    result <- g_dbus_annotation_info_ref _obj'
    checkUnexpectedReturnNULL "g_dbus_annotation_info_ref" result
    result' <- (wrapBoxed DBusAnnotationInfo) result
    touchManagedPtr _obj
    return result'

data DBusAnnotationInfoRefMethodInfo
instance (signature ~ (m DBusAnnotationInfo), MonadIO m) => MethodInfo DBusAnnotationInfoRefMethodInfo DBusAnnotationInfo signature where
    overloadedMethod _ = dBusAnnotationInfoRef

-- method DBusAnnotationInfo::unref
-- method type : OrdinaryMethod
-- Args : [Arg {argCName = "_obj", argType = TInterface "Gio" "DBusAnnotationInfo", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, argCallerAllocates = False, transfer = TransferNothing}]
-- Lengths : []
-- returnType : TBasicType TVoid
-- throws : False
-- Skip return : False

foreign import ccall "g_dbus_annotation_info_unref" g_dbus_annotation_info_unref :: 
    Ptr DBusAnnotationInfo ->               -- _obj : TInterface "Gio" "DBusAnnotationInfo"
    IO ()


dBusAnnotationInfoUnref ::
    (MonadIO m) =>
    DBusAnnotationInfo                      -- _obj
    -> m ()                                 -- result
dBusAnnotationInfoUnref _obj = liftIO $ do
    let _obj' = unsafeManagedPtrGetPtr _obj
    g_dbus_annotation_info_unref _obj'
    touchManagedPtr _obj
    return ()

data DBusAnnotationInfoUnrefMethodInfo
instance (signature ~ (m ()), MonadIO m) => MethodInfo DBusAnnotationInfoUnrefMethodInfo DBusAnnotationInfo signature where
    overloadedMethod _ = dBusAnnotationInfoUnref

-- method DBusAnnotationInfo::lookup
-- method type : MemberFunction
-- Args : [Arg {argCName = "annotations", argType = TCArray True (-1) (-1) (TInterface "Gio" "DBusAnnotationInfo"), direction = DirectionIn, mayBeNull = True, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, argCallerAllocates = False, transfer = TransferNothing},Arg {argCName = "name", argType = TBasicType TUTF8, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, argCallerAllocates = False, transfer = TransferNothing}]
-- Lengths : []
-- returnType : TBasicType TUTF8
-- throws : False
-- Skip return : False

foreign import ccall "g_dbus_annotation_info_lookup" g_dbus_annotation_info_lookup :: 
    Ptr (Ptr DBusAnnotationInfo) ->         -- annotations : TCArray True (-1) (-1) (TInterface "Gio" "DBusAnnotationInfo")
    CString ->                              -- name : TBasicType TUTF8
    IO CString


dBusAnnotationInfoLookup ::
    (MonadIO m) =>
    Maybe ([DBusAnnotationInfo])            -- annotations
    -> T.Text                               -- name
    -> m T.Text                             -- result
dBusAnnotationInfoLookup annotations name = liftIO $ do
    maybeAnnotations <- case annotations of
        Nothing -> return nullPtr
        Just jAnnotations -> do
            let jAnnotations' = map unsafeManagedPtrGetPtr jAnnotations
            jAnnotations'' <- packZeroTerminatedPtrArray jAnnotations'
            return jAnnotations''
    name' <- textToCString name
    result <- g_dbus_annotation_info_lookup maybeAnnotations name'
    checkUnexpectedReturnNULL "g_dbus_annotation_info_lookup" result
    result' <- cstringToText result
    whenJust annotations (mapM_ touchManagedPtr)
    freeMem maybeAnnotations
    freeMem name'
    return result'

type family ResolveDBusAnnotationInfoMethod (t :: Symbol) (o :: *) :: * where
    ResolveDBusAnnotationInfoMethod "ref" o = DBusAnnotationInfoRefMethodInfo
    ResolveDBusAnnotationInfoMethod "unref" o = DBusAnnotationInfoUnrefMethodInfo
    ResolveDBusAnnotationInfoMethod l o = MethodResolutionFailed l o

instance (info ~ ResolveDBusAnnotationInfoMethod t DBusAnnotationInfo, MethodInfo info DBusAnnotationInfo p) => IsLabelProxy t (DBusAnnotationInfo -> p) where
    fromLabelProxy _ = overloadedMethod (MethodProxy :: MethodProxy info)

#if MIN_VERSION_base(4,9,0)
instance (info ~ ResolveDBusAnnotationInfoMethod t DBusAnnotationInfo, MethodInfo info DBusAnnotationInfo p) => IsLabel t (DBusAnnotationInfo -> p) where
    fromLabel _ = overloadedMethod (MethodProxy :: MethodProxy info)
#endif


